-- allow ~ 40 MB instead of just 7.5 MB. Prevents "Runtime Error: Out of scripter memory"
if (heapSize < 200000) then
        heapSize = 2000000
		
-- force useing one CPU core
if SysInfo.CPUCount == 1 then
     TargetAffinity = 1
    else (
     TargetAffinity = 0
     for CoreID = 2 to SysInfo.CPUCount do
      TargetAffinity = (Bit.Set TargetAffinity CoreID true)
    )
    SysInfo.ProcessAffinity = TargetAffinity

---Constants
global RipSignature      = 0xDEADC0DE
global RipFileVersion    = 3
global TextureFileNameLen= 20
global ShaderFileNameLen = 20
global SemanticLen       = 64
struct VertexElement (Semantic, Offset, Size)




---Global vars
global g_ImportType = 3       --- Group/Single/List  (0,1,2)
global g_InputSrc   = ""      --- Source Dir/File
global g_VertexFormatRecog = 0 --- Auto/Manual  (0,1)
global g_Tex0_FileLev = 0

global g_PosX_Idx = 0
global g_PosY_Idx = 0
global g_PosZ_Idx = 0
global g_NormX_Idx = 0
global g_NormY_Idx = 0
global g_NormZ_Idx = 0
global g_Tc0_U_Idx = 0
global g_Tc0_V_Idx = 0


fn ReadFixedString bstream fixedLen =
(
   local str = ""
   for i = 1 to fixedLen do
   (
      str0 = ReadByte bstream #unsigned
      if str0!=0 do str+= bit.intAsChar str0
   )
   str
)


----------------------------
fn ImportRip RipFilePath =
(
	f = fopen RipFilePath "rb"

	Signature     = readlong f #unsigned
	Version       = readlong f #unsigned
	dwFacesCnt    = readlong f #unsigned
	dwVertexesCnt = readlong f #unsigned
	Culling       = readlong f #unsigned
	VertexElements= readlong f #unsigned
	VertexSize    = readlong f #unsigned

	
	TextureFile0 = ReadFixedString f TextureFileNameLen
	TextureFile1 = ReadFixedString f TextureFileNameLen
	TextureFile2 = ReadFixedString f TextureFileNameLen
	TextureFile3 = ReadFixedString f TextureFileNameLen
	TextureFile4 = ReadFixedString f TextureFileNameLen
	TextureFile5 = ReadFixedString f TextureFileNameLen
	TextureFile6 = ReadFixedString f TextureFileNameLen
	TextureFile7 = ReadFixedString f TextureFileNameLen

	VertexShaderFile= ReadFixedString f ShaderFileNameLen
	PixelShaderFile = ReadFixedString f ShaderFileNameLen

	Face_array= #()
	Vert_array= #()
	UV_array  = #()	
	
	
	---Read vertex declaration
	TexCoordIdx = 0
	
	print( "Vertex elements: " + VertexElements as String )
	
	for x = 1 to VertexElements do(
		print( "Idx: " + x as String )
		
		sem = ReadFixedString f SemanticLen
		offs= readlong f #unsigned
		size= readlong f #unsigned
		
		print( "Seman:" + sem )
		print( "Offs: " + offs as String )
		print( "Size: " + size as String )
		
		if g_VertexFormatRecog == 0 do ( ---AUTO recognition	
			if sem == "POSITION" do (  --- Get as "XYZ_"
				g_PosX_Idx = offs / 4
				g_PosY_Idx = g_PosX_Idx + 1
				g_PosZ_Idx = g_PosX_Idx + 2
			)
			
			if sem == "NORMAL" do (
				g_NormX_Idx = offs / 4
				g_NormY_Idx = g_NormX_Idx + 1
				g_NormZ_Idx = g_NormX_Idx + 2
			)
			
			if sem == "TEXCOORD" do (
				if TexCoordIdx == 0 do(
					g_Tc0_U_Idx = offs / 4
					g_Tc0_V_Idx = g_Tc0_U_Idx + 1
					
					TexCoordIdx = TexCoordIdx + 1
				)
			)
		)
	)
	
	
	---Read indexes
	for x = 1 to dwFacesCnt do(
		i0 = readlong f #unsigned
		i1 = readlong f #unsigned
		i2 = readlong f #unsigned
		append Face_array[i0+1,i1+1,i2+1]
	)
	
	
	print( "PosX idx: " + g_PosX_Idx as String )
	print( "PosY idx: " + g_PosY_Idx as String )
	print( "PosZ idx: " + g_PosZ_Idx as String )
	print( "NormX idx: " + g_NormX_Idx as String )
	print( "NormY idx: " + g_NormY_Idx as String )
	print( "NormZ idx: " + g_NormZ_Idx as String )
	print( "Tu0 idx: " + g_Tc0_U_Idx as String )
	print( "Tv0 idx: " + g_Tc0_V_Idx as String )	
	
	
	
	---Read vertexes
	for k = 1 to dwVertexesCnt do(
		vx = 0.0
		vy = 0.0
		vz = 0.0
		vw = 0.0
		nx = 0.0
		ny = 0.0
		nz = 0.0
		nw = 0.0
		tu = 0.0
		tv = 0.0
	
		for j = 0 to (VertexSize / 4 - 1) do(
			z = readfloat f
			if j == g_PosX_Idx do vx = z
			if j == g_PosY_Idx do vy = z
			if j == g_PosZ_Idx do vz = z
			
			if j == g_NormX_Idx do nx = z
			if j == g_NormY_Idx do ny = z
			if j == g_NormZ_Idx do nz = z
			
			if j == g_Tc0_U_Idx do tu = z
			if j == g_Tc0_V_Idx do tv = z
		)
		append Vert_array[vx,vy,vz]
		append UV_array[tu,tv,0]
	)
	
	TexFile = ""
	---FIX use array
	if g_Tex0_FileLev == 0 then(
		TexFile = TextureFile0
	)
	else if g_Tex0_FileLev == 1 then(
		TexFile = TextureFile1
	)
	else if g_Tex0_FileLev == 2 then(
		TexFile = TextureFile2
	)
	else if g_Tex0_FileLev == 3 then(
		TexFile = TextureFile3
	)	
	else if g_Tex0_FileLev == 4 then(
		TexFile = TextureFile4
	)
	else if g_Tex0_FileLev == 5 then(
		TexFile = TextureFile5
	)
	else if g_Tex0_FileLev == 6 then(
		TexFile = TextureFile6
	)
	else if g_Tex0_FileLev == 7 then(
		TexFile = TextureFile7
	)
	
	TexFileName = getFilenamePath RipFilePath 
	TexFileName = TexFileName + TexFile
	print ( "TEXTURE: " + TexFileName )
	
	
	---Material
	thenewmaterial = multimaterial numsubs:1
	thenewsubmaterial = standardmaterial name:TexFile
	thenewsubmaterial.diffusemap = bitmaptexture name:TexFile
	thenewsubmaterial.diffusemap.filename = TexFileName
	thenewmaterial.materiallist[1] = thenewsubmaterial
	showtexturemap thenewsubmaterial thenewsubmaterial.diffusemap true

	msh = mesh vertices:Vert_array faces:Face_array
	setNumTVerts msh UV_array.count
	
	
	msh.name = getFilenameFile RipFilePath
	scale msh [100,100,100]
	--rotate msh (angleaxis spiner_X_rotate [1,0,0])
		
	for i = 1 to UV_array.count do (setTVert msh i UV_array[i]) 
	buildTVFaces msh false
	for i = 1 to Face_array.count do (setTVFace msh i Face_array[i])

	msh.material = thenewmaterial
)


rollout MainRollout "Ninja Ripper Importer v1.0 Beta 2" width:300 height:430
(
	local	Files = #()
	
	-- Source select
	groupBox grp1 "Source select" pos:[5,5] width:289 height:113
	radioButtons RadioImport "" pos:[58,27] width:201 height:16 labels:#("Group", "Single", "List File") default:2 columns:3
		
	label lbl1 "Input Dir/File:" pos:[12,58] width:68 height:17
	editText InputSrc "" pos:[84,55] width:169 height:20
	button SelectSrc "..." pos:[260,56] width:26 height:19 toolTip:""
	
	label lbl10 "RIP File Nums" pos:[13,85] width:69 height:18
	editText RipList "" pos:[84,82] width:202 height:20
		
	-- Vertex Format
	groupBox grp2 "Vertex Format" pos:[5,125] width:289 height:168
	--imgTag theImgTag "Bitmap" pos:[5,150] width:168 height:20 bitmap:(bitmap 80 50 color:gray) align:#right

	radioButtons RadioVertexFormat "" pos:[85,144] width:58 height:32 enabled:true labels:#("Auto", "Manual") default:1 columns:2
	
	label lbl4 "Position" pos:[65,170] width:41 height:14
	label lbl7 "Normal" pos:[127,170] width:37 height:14
	label lbl5 "TexCoord 0" pos:[176,170] width:58 height:14
	
	editText pos_x "x" pos:[57,195] width:42 height:20
	editText pos_y "y" pos:[57,225] width:42 height:20
	editText pos_z "z" pos:[57,256] width:42 height:20
	
	editText norm_x "x" pos:[118,195] width:42 height:20
	editText norm_y "y" pos:[118,225] width:42 height:20
	editText norm_z "z" pos:[118,256] width:42 height:20
	
	spinner tc0_u "u" pos:[176,195] width:40 height:16 range:[0,500,0] type:#integer
	spinner tc0_v "v" pos:[176,225] width:40 height:16 range:[0,500,0] type:#integer
	--editText tc0_u "u" pos:[176,195] width:42 height:20
	--editText tc0_v "v" pos:[176,225] width:42 height:20
	--button plusUVone "+1" pos:[233,204] width:40 height:30 enabled:false
	
	-- Import button
	label lbl6 "Tex.0 File Level" pos:[16,310] width:77 height:15
	spinner spnTex0Lev "" pos:[100,310] width:40 height:16 range:[0,7,0] type:#integer
	--label lblscale "Scale" pos:[16,330] width:77 height:15 enabled:true
	--spinner spnscale "" pos:[100,330] width:40 height:16 range:[1,10000,100] type:#integer enabled:true
	
	--label lblrotate "Rotate X" pos:[16,350] width:77 height:15 enabled:true
	--spinner spnrotate "" pos:[100,350] width:40 height:16 range:[0,360,90] scale:90 type:#integer enabled:true

	button BtnImport "Import" pos:[182,303] width:105 height:52
		
	
	on MainRollout open  do (
		---Init values
		pos_x.text = "0"
		pos_y.text = "1"
		pos_z.text = "2"
		
		norm_x.text = "3"
		norm_y.text = "4"
		norm_z.text = "5"
		
		tc0_u.value  = 6
		tc0_v.value  = 7
		
		spiner_X_rotate = 90
		
	)
	
	on plusUVone pressed do
		
	(
		get tc0_u.value = 1
		tc0_v.value = 1
	)
	
	on SelectSrc pressed  do (
		if RadioImport.state == 1 then (	---Group
			g_InputSrc   = getSavePath caption:"my title" initialDir:"$scripts"
			if g_InputSrc != undefined do (
				g_ImportType  = 0
				InputSrc.text = g_InputSrc
				print ( "Dir selected: " + g_InputSrc )
				Files = (GetFiles (g_InputSrc + "/*.rip"))
				if Files.Count != 0 then
					RipList.Text = ("1.." + "1" + Files.Count as string)
				else
					RipList.Text = "<NO FILES FOUND>"
			)
		)
		else if RadioImport.state == 2 then (   ---Single
			g_InputSrc = getOpenFileName \ 
							caption:"Ninja Ripper File Select" \
							types:"Ninja Ripper File(*.rip)|*.rip" \
							historyCategory:"Ninja Ripper"
			if g_InputSrc != undefined do (
				g_ImportType = 1
				InputSrc.text = g_InputSrc
				print ( "File selected: " + g_InputSrc )
			)
		)
		else if RadioImport.state == 3 then ( ---List file
			g_InputSrc = getOpenFileName \ 
							caption:"Ninja Ripper List File Select" \
							types:"Ninja Ripper List File(*.lst)|*.lst" \
							historyCategory:"Ninja Ripper"
			if g_InputSrc != undefined do(
				g_ImportType = 2
				InputSrc.text = g_InputSrc
				print ( "List File selected: " + g_InputSrc )
			)
		)
	)
	
	
	
	---Import button
	on BtnImport pressed  do (
		
		kkk = spnscale.value
		spiner_X_rotate = spnrotate.value
		
		if RadioVertexFormat.state == 1 then ( ---Auto
			print "***Auto***"
			g_VertexFormatRecog = 0
		)
		else ( ---Manual
			print "***Manual***"
			g_VertexFormatRecog = 1
			
			---Position
			g_PosX_Idx = ( pos_x.text as Integer )
			g_PosY_Idx = ( pos_y.text as Integer )
			g_PosZ_Idx = ( pos_z.text as Integer )
			
			---Normals
			g_NormX_Idx = ( norm_x.text as Integer )
			g_NormY_Idx = ( norm_y.text as Integer )
			g_NormZ_Idx = ( norm_z.text as Integer )

			---Tex coords
			g_Tc0_U_Idx = ( tc0_u.value as Integer )
			g_Tc0_V_Idx = ( tc0_v.value as Integer )
		)
		
		g_Tex0_FileLev = spnTex0Lev.value as Integer
		
		case g_ImportType of (
			0: (
				for FileID in ((Execute ("#{" + RipList.Text + "}")) as array) do
					ImportRip Files[FileID]
			)
			1:
				ImportRip g_InputSrc
			2: (
				--list
			)
		)
		
	)
		
)

createDialog MainRollout 300 368 100 100
